﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Services;
using System.Xml;
using System.Xml.Linq;
using System.Collections;
using MySql.Data.MySqlClient;
using System.Media;
namespace SearchBook_WebService
{
    /// <summary>
    /// Summary description for Service1
    /// </summary>
    [WebService(Namespace = "http://tempuri.org/")]
    [WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]
    [System.ComponentModel.ToolboxItem(false)]
    // To allow this Web Service to be called from script, using ASP.NET AJAX, uncomment the following line. 
    // [System.Web.Script.Services.ScriptService]
    public class Service1 : System.Web.Services.WebService
    {
        //DB Config
        string strIp = "127.0.0.1";
        string strId = "root";
        string strPass = "ocpadmin#";

        #region openapi webservice
        [WebMethod]
        public BookList BookApi(string pQuery)
        {
            //XmlDocument myXml = new XmlDocument();
            string url="http://openapi.naver.com/search?key=ac1e0c45422f90f3807a471570ee20a5&query=" + pQuery + "&display=10&start=1&target=book&sort=sim";
            XDocument myXml = XDocument.Load(url);

            BookList bl = new BookList();

            var result = from item in myXml.Descendants("item")
                         select new
                         {
                             title = item.Element("title").Value.Replace("<b>","").Replace("</b>",""),
                             image = item.Element("image").Value,
                             link = item.Element("link").Value,
                             description = item.Element("description").Value,
                             price = item.Element("price").Value,
                             discount = item.Element("discount").Value,
                             author = item.Element("author").Value,
                             pubdate = item.Element("pubdate").Value,
                             publisher = item.Element("publisher").Value,
                         };


            
            foreach (var searchResult in result)
            {
                bl.Add(new Book(searchResult.title,searchResult.image,searchResult.link,searchResult.description,searchResult.price,searchResult.discount,searchResult.author,searchResult.pubdate,searchResult.publisher));             
            }           
            return bl;
            
            //return al;
        }

        [WebMethod]
        public BlogList BlogApi(string pQuery)
        {
            string url = "http://openapi.naver.com/search?key=ac1e0c45422f90f3807a471570ee20a5&query=" + pQuery + "&display=10&start=1&target=blog&sort=sim";
            XDocument myXml = XDocument.Load(url);

            BlogList bl = new BlogList();

            var result = from item in myXml.Descendants("item")
                         select new
                         {
                             title = item.Element("title").Value.Replace("<b>", "").Replace("</b>", ""),                        
                             link = item.Element("link").Value,
                             description = item.Element("description").Value,
                             
                         };



            foreach (var searchResult in result)
            {
                bl.Add(new Blog(searchResult.title,searchResult.link, searchResult.description));
            }

            return bl;
        }

        [WebMethod]
        public WebPageList WebPageAPI(string pQuery)
        {
            string url = "http://openapi.naver.com/search?key=ac1e0c45422f90f3807a471570ee20a5&query=" + pQuery + "&display=10&start=1&target=webkr&sort=sim";
            XDocument myXml = XDocument.Load(url);

            WebPageList wl = new WebPageList();

            var result = from item in myXml.Descendants("item")
                         select new
                         {
                             title = item.Element("title").Value.Replace("<b>", "").Replace("</b>", ""),
                             link = item.Element("link").Value,
                             description = item.Element("description").Value,

                         };

            foreach (var searchResult in result)
            {
                wl.Add(new WebPage(searchResult.title, searchResult.link, searchResult.description));
            }

            return wl;
        }
        #endregion
        #region use db for bookcase
        [WebMethod]
        public BookCaseList ViewDbBook(int pPageNum)
        {
            MySqlConnection conn;
            int nPageCount = 15; //모자이크뷰에 보여질 개수 즉 페이지 개수
            int nStartNumber = (int)(pPageNum - 1) * nPageCount;
            

            BookCaseList bcl = new BookCaseList();
          
            string connStr = String.Format("server={0};user id={1}; password={2}; database=book; pooling=false", strIp, strId, strPass);
            //string strSql = "select * from bookcase limit 0,15";  //15개만 보낸다.
            string strSql = "select * from bookcase limit " + nStartNumber + "," + nPageCount;  //15개만 보낸다.
            string countSql = "select count(*) from bookcase";  //15개만 보낸다.
            string TotalPageCount;
            try
            {
                conn = new MySqlConnection(connStr); 
                conn.Open(); // 접속

                MySqlDataReader reader = null;
                MySqlCommand cmd = new MySqlCommand(strSql, conn);
                MySqlCommand pagecount = new MySqlCommand(countSql, conn);

                try
                {                       
                    
                    TotalPageCount= pagecount.ExecuteScalar().ToString(); //db안에있는개수 for paging
                    reader = cmd.ExecuteReader();
                    while (reader.Read())                
                    {
                        bcl.Add(new BookCase(reader.GetString(0), reader.GetString(1), reader.GetString(2), reader.GetString(3), reader.GetString(4), reader.GetString(5)));
                    }
                }
                catch (MySqlException)
                {
                    //MessageBox.Show("Failed to populate database list: " + ex.Message);
                }
                finally
                {
                    if (reader != null) reader.Close();
                }
            }
            catch (MySqlException) // 익섹션처리는 MySqlException으로 정의
            {
                //MessageBox.Show("Error connecting to the server: " + ex.Message);
            }

            return bcl;
        }
        
     
        [WebMethod]
        public void InsertDbBook(string pTitle, string pPrice, string pAuthor, string pContents,string pImage)
        {
            MySqlConnection conn;
            BookCaseList bcl = new BookCaseList();
            string connStr = String.Format("server={0};user id={1}; password={2}; database=book; pooling=false", strIp, strId, strPass);
            string strSql = "insert into bookcase values('1','" + pTitle + "','" + pPrice +"','"+ pAuthor + "','"+pContents+ "','"+pImage+"')" ;

            try
            {
                conn = new MySqlConnection(connStr);
                conn.Open(); // 접속

                MySqlDataReader reader = null;
                MySqlCommand cmd = new MySqlCommand(strSql, conn);
                

                try
                {
                    cmd.ExecuteNonQuery();

                
                }
                catch (MySqlException)
                {
                    //MessageBox.Show("Failed to populate database list: " + ex.Message);
                }
                finally
                {
                    if (reader != null) reader.Close();
                }
            }
            catch (MySqlException) // 익섹션처리는 MySqlException으로 정의
            {
                //MessageBox.Show("Error connecting to the server: " + ex.Message);
            }
        }

        [WebMethod]
        public void UpdateDbBook(string pTitle, string pPrice, string pAuthor, string pContents,string pImage)
        {
            MySqlConnection conn;
            BookCaseList bcl = new BookCaseList();
            
            string connStr = String.Format("server={0};user id={1}; password={2}; database=book; pooling=false", strIp, strId, strPass);
            string strSql = "update bookcase set contents='"+pContents +"' where image='"+pImage+"'" ;

            try
            {
                conn = new MySqlConnection(connStr);
                conn.Open(); // 접속

                MySqlDataReader reader = null;
                MySqlCommand cmd = new MySqlCommand(strSql, conn);


                try
                {
                    cmd.ExecuteNonQuery();


                }
                catch (MySqlException)
                {
                    //MessageBox.Show("Failed to populate database list: " + ex.Message);
                }
                finally
                {
                    if (reader != null) reader.Close();
                }
            }
            catch (MySqlException) // 익섹션처리는 MySqlException으로 정의
            {
                //MessageBox.Show("Error connecting to the server: " + ex.Message);
            }
        }
        
        [WebMethod]
        public void DeleteDbBook(string pImage)
        {
            MySqlConnection conn;
            BookCaseList bcl = new BookCaseList();

            string connStr = String.Format("server={0};user id={1}; password={2}; database=book; pooling=false", strIp, strId, strPass);
            string strSql = "delete from bookcase where image='" + pImage + "'";

            try
            {
                conn = new MySqlConnection(connStr);
                conn.Open(); // 접속

                MySqlDataReader reader = null;
                MySqlCommand cmd = new MySqlCommand(strSql, conn);


                try
                {
                    cmd.ExecuteNonQuery();


                }
                catch (MySqlException)
                {
                    //MessageBox.Show("Failed to populate database list: " + ex.Message);
                }
                finally
                {
                    if (reader != null) reader.Close();
                }
            }
            catch (MySqlException) // 익섹션처리는 MySqlException으로 정의
            {
                //MessageBox.Show("Error connecting to the server: " + ex.Message);
            }
        }

        #endregion
        #region Book Class


        //book class for output
        public class BookList : List<Book> { }        
        public class Book
        {

            public Book() { }

            public Book(string pTitle, string pImage, string pLink, string pDescription, string pPrice, string pDiscount, string pAuthor, string pPubdate, string pPublisher)
            {
                this.title = pTitle;
                this.image = pImage;  
                
                this.link = pLink;
                this.description = pDescription;
                this.price = pPrice;
                this.discount = pDiscount;
                this.author = pAuthor;
                this.pubdate = pPubdate;
                this.publisher = pPublisher;
            }

            public string title;

            public string image;

            public object image_bitmap;
           
            public string link; 

            public string description; //상세정보

            public string price;     //가격

            public string discount;  //할인가격

            public string author;    //저자정보

            public string pubdate;   //출간일

            public string publisher; //출판사
        }

        //for blog
        public class BlogList : List<Blog> { }
        public class Blog
        {

            public Blog() { }

            public Blog(string pTitle, string pLink, string pDescription)
            {
                this.title = pTitle;                
                this.link = pLink;
                this.description = pDescription;                
            }

            public string title;           

            public string link;

            public string description; //상세정보
        }

        //for WebPage
        public class WebPageList : List<WebPage> { }
        public class WebPage
        {

            public WebPage() { }

            public WebPage(string pTitle, string pLink, string pDescription)
            {
                this.title = pTitle;
                this.link = pLink;
                this.description = pDescription;
            }

            public string title;

            public string link;

            public string description; //상세정보
        }

        //for bookViewer to use DB
        public class BookCaseList : List<BookCase> { }
        public class BookCase
        {

            public BookCase() { }

            public BookCase(string pNo, string pTitle, string pPrice,string pAuthor, string pContents,string pImage)
            {
                this.no = pNo;
                this.title = pTitle;
                this.price = pPrice;
                this.author = pAuthor;
                this.contents = pContents;
                this.image = pImage;                
            }

            public string no;
            public string title;
            public string price;
            public string author;
            public string contents;
            public string image;

        }
        #endregion




    }
}
